//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

#include "CsvEdUnit.h"
#include "ABOUT.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	CsvGrid = new TCsvGrid(this);
	CsvGrid->SetParms(StringGrid1);
	delete StringGrid1;

	TCsvGrid *grid = new TCsvGrid(CsvGrid->Parent);
	grid->SetParms(CsvGrid);

	GridList = new TCsvGridList;
	GridList->Add(grid);

	CsvGrid->Visible = false;
	CsvGrid->Parent = this;

	CsvGrid->SetEncoding(OpenTextFileDialog1);
	CsvGrid->SetEncoding(SaveTextFileDialog1);

	DragAcceptFiles(Handle, true);
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
	delete GridList;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	for (int i = 0; i < GridList->Count; i++) {
		if (!GridList->Items[i]->CanClose()) {
			CanClose = false;
			return;
		}
	}
	CanClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CloseActExecute(TObject *Sender)
{
	// ANeBuȃ^uN[Y
	for (int i = 0; i < GridList->Count; i++) {
		if (GridList->Items[i]->Parent == PageControl1->ActivePage) {
			if (!GridList->Items[i]->CanClose())
				return;
			GridList->Delete(i);
			if (GridList->Count == 0) {
				TCsvGrid *grid = new TCsvGrid(PageControl1->ActivePage);
				grid->SetParms(CsvGrid);
				grid->Parent = PageControl1->ActivePage;
				grid->Visible = true;
				GridList->Add(grid);
				PageControl1->ActivePage->Caption = _T("OȂ");
			} else {
				delete PageControl1->ActivePage;
			}
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenActExecute(TObject *Sender)
{
	// J
	if (!OpenTextFileDialog1->Execute(this->Handle))
		return;
	for (int i = 0; i < OpenTextFileDialog1->Files->Count; i++) {
		OpenFile(OpenTextFileDialog1->Files->Strings[i],
				 OpenTextFileDialog1->EncodingIndex);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenFile(const UnicodeString &fname, int encidx)
{
	TCsvGrid *grid;
	TTabSheet *sheet;
	int ix;
	for (ix = 0; ix < GridList->Count; ix++) {
		if (GridList->Items[ix]->IsEmpty())
			break;
	}
	if (ix < GridList->Count) {
		grid = GridList->Items[ix];
		sheet = static_cast<TTabSheet *>(grid->Parent);
	} else {
		sheet = new TTabSheet(this);
		sheet->PageControl = PageControl1;
		grid = new TCsvGrid(sheet);
		grid->SetParms(CsvGrid);
		grid->Parent = sheet;
		grid->Visible = true;
		GridList->Add(grid);
	}
	sheet->Caption = ExtractFileName(fname);
	if (sheet != PageControl1->ActivePage)
		PageControl1->ActivePage = sheet;
	grid->ReadCsv(fname, encidx);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveActExecute(TObject *Sender)
{
	// ۑ
	TCsvGrid *grid = NULL;
	for (int i = 0; i < GridList->Count; i++) {
		if (GridList->Items[i]->Parent == PageControl1->ActivePage) {
			grid = GridList->Items[i];
			break;
		}
	}
	if (grid != NULL) {
		if (grid->FileName.IsEmpty())
			SaveAsActExecute(Sender);
		else
			grid->Save();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveAsActExecute(TObject *Sender)
{
	// Otĕۑ
	TCsvGrid *grid = NULL;
	for (int i = 0; i < GridList->Count; i++) {
		if (GridList->Items[i]->Parent == PageControl1->ActivePage) {
			grid = GridList->Items[i];
			break;
		}
	}
	if (grid != NULL && SaveTextFileDialog1->Execute(this->Handle)) {
		grid->SaveAs(SaveTextFileDialog1->FileName,
					SaveTextFileDialog1->EncodingIndex);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AboutActExecute(TObject *Sender)
{
	TAboutBox *ab = new TAboutBox(this);
	ab->ShowModal();
	delete ab;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SearchActExecute(TObject *Sender)
{
	FindDialog1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SearchNextActExecute(TObject *Sender)
{
	FindDialog1Find(FindDialog1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReplaceActExecute(TObject *Sender)
{
	ReplaceDialog1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FindDialog1Find(TObject *Sender)
{
	TCsvGrid *grid = NULL;
	for (int i = 0; i < GridList->Count; i++) {
		if (GridList->Items[i]->Parent == PageControl1->ActivePage) {
			grid = GridList->Items[i];
			break;
		}
	}
	if (grid != NULL) {
		grid->Find(dynamic_cast<TFindDialog *>(Sender));
		if (Sender == FindDialog1)
			ReplaceDialog1->FindTextW = FindDialog1->FindTextW;
		else if (Sender == ReplaceDialog1)
			FindDialog1->FindTextW = ReplaceDialog1->FindTextW;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReplaceDialog1Find(TObject *Sender)
{
	FindDialog1Find(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReplaceDialog1Replace(TObject *Sender)
{
	TCsvGrid *grid = NULL;
	for (int i = 0; i < GridList->Count; i++) {
		if (GridList->Items[i]->Parent == PageControl1->ActivePage) {
			grid = GridList->Items[i];
			break;
		}
	}
	if (grid != NULL) {
		grid->Replace(dynamic_cast<TReplaceDialog *>(Sender));
		if (Sender == ReplaceDialog1)
			FindDialog1->FindTextW = ReplaceDialog1->FindTextW;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WMDropFiles(TWMDropFiles &Mes)
{
	int fcount = DragQueryFile((HDROP)Mes.Drop, 0xFFFFFFFF, NULL, 0);
	for (int i = 0; i < fcount; i++) {
		TCHAR fname[MAX_PATH];
		DragQueryFile((HDROP)Mes.Drop, i, fname, MAX_PATH);
		OpenFile(UnicodeString(fname), -1);
	}
	DragFinish((HDROP)Mes.Drop);
}
//---------------------------------------------------------------------------

