//---------------------------------------------------------------------------

#ifndef CsvGridH
#define CsvGridH
//---------------------------------------------------------------------------
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
#include "AcotGrid.h"
//
//---------------------------------------------------------------------------
// GR[hƃR[hy[W
#define UCIO_SJIS		932
#define UCIO_EUC		20932
#define UCIO_JIS		50222
#define UCIO_UTF7		65000
#define UCIO_UTF8		65001
#define UCIO_UTF16		1200
#define UCIO_UTF16BE	1201

//---------------------------------------------------------------------------
class TCsvGrid : public TAcotGrid
{
protected:
	int ModCount;
	TCHAR SepChar;
	UnicodeString EndOfLine;
	bool __fastcall CsvGetLine(
					const UnicodeString &str, // 镶
					int idx, // JnCfbNX
					TStringList *data, // J̃f[^
					TCHAR sepch, // ؂蕶
					int &cnt // vf
				);
	bool __fastcall Find_a(TFindDialog *dlg);
	bool __fastcall Replace_a(TReplaceDialog *dlg);

public:
	UnicodeString FileName;
	int EncIndex;
	int CodePage;

	__fastcall TCsvGrid(TComponent* Owner);
	__fastcall ~TCsvGrid();

	bool __fastcall CanClose();
	bool __fastcall IsEmpty();

	void __fastcall SetEncoding(TOpenTextFileDialog *dlg);
	void __fastcall SetEncoding(TSaveTextFileDialog *dlg);
	int __fastcall ReadCsv(const UnicodeString &filename, int encidx);
	int __fastcall Save();
	int __fastcall SaveAs(const UnicodeString &filename, int encidx);
	bool __fastcall Find(TFindDialog *dlg);
	bool __fastcall Replace(TReplaceDialog *dlg);
};
//---------------------------------------------------------------------------
#endif
