#ifndef ObjList_header
#define ObjList_header
//
// TList hIuWFNg̃Xg̃ev[g
//	Example
//		class ClassX { ... };
//		typedef CObjList<ClassX> ClassXList;
//		ClassXList *list = new ClassXList;
//		list->Add(new ClassX);
//

template <class T> class CObjList : public TList
{
private:
	T * __fastcall GetItem(int Index) {
		return (T *)TList::Items[Index];
	}
	void __fastcall SetItem(int Index, T *Value) {
		TList::Items[Index] = (void *)Value;
	}
	int __fastcall GetCount() {
		return TList::Count;
	}
	void __fastcall SetCount(int Value) {
		int i;
		if (Value < 0)
        	Value = 0;
		i = GetCount();
		if (Value > i) {
			TList::Count = Value;
			for (; i < Value; i++) {
				SetItem(i, new T);
			}
		} else if (Value < i) {
			for (; i > Value; i--) {
				if (GetItem(i-1) != NULL)
					delete GetItem(i-1);
			}
			TList::Count = Value;
		}
	}
public:
	__property T * Items[int Index] = {read=GetItem, write=SetItem};
	__property int Count = {read=GetCount, write=SetCount};
	__fastcall CObjList() : TList() { }
	void __fastcall Clear(void) {
		for (int i = Count - 1; i >= 0; i--) {
			if (GetItem(i) != NULL)
				delete GetItem(i);
		}
		TList::Clear();
	}
	void __fastcall Delete(int Index) {
		if (GetItem(Index) != NULL)
			delete GetItem(Index);
		TList::Delete(Index);
	}
	int __fastcall Add(T *Item) {
		return TList::Add((void *)Item);
	}
	void __fastcall Insert(int Index, T *Item) {
		TList::Insert(Index, (void *)Item);
	}
	__fastcall ~CObjList() { Clear(); }
};


#endif
